;-------------------------------------------------------------------------------
; Integer2ASCII 32-bittisille etumerkittmille kokonaisluvuille
;-------------------------------------------------------------------------------

               MACHINE  68040

               incdir   "Work:Assembler/include"

;-------------------------------------------------------------------------------
; Macros and stuff...
;-------------------------------------------------------------------------------
LibCall        MACRO
               move.l   \1base,a6
               jsr      \2(a6)
               ENDM

OpenLibrary    equ      -$0228
CloseLibrary   equ      -$019e
Write          equ      -$0030
Output         equ      -$003c

Execbase       equ      4

;-------------------------------------------------------------------------------
; The program begins...
;-------------------------------------------------------------------------------

   section  Programcode,Code

               movem.l  d2-d7/a2-a6,-(sp)

; Avataan kirjastot

               lea      dosname,a1
               moveq    #0,d0
               LibCall  Exec,OpenLibrary
               move.l   d0,Dosbase

               LibCall  Dos,Output           ; For printing...
               move.l   d0,outfile           ;

               move.l   #234,d0              ; The number to be converted
               lea      Number,a2            ; The digits will be stored here

;-------------------------------------------------------------------------------
; Integer2ASCII_32bit, '040 version.
; Uses CPU registers D0-D3,D7 & A2 and FPU register FP0.
;
; - Converts 32 bit unsigned integer given in D0 into ASCII, destination
;   address (where the digits are stored) is given in A2
;-------------------------------------------------------------------------------
Integer2ASCII_32bit

               fmove.l  d0,fp0               ; Konvertoitava numero FP0:aan
               moveq    #0,d7

; Lasketaan digittien mr, n = trunc(LOG10(luku)) + 1

               fadd.x   #0.1,fp0             ; Pyristysongelman vuoksi
               flog10   fp0                  ; LOG10
               fmove.l  fp0,d7               ; DBF-kskyn vuoksi 1:t ei list

; Konvertoidaan annettu 32-bittinen kokonaisluku ASCII-muotoon
               
dloop          moveq    #0,d2
               moveq    #0,d3

               move.l   d0,d1                ; Tykopio D0:sta

               fmove.l  d7,fp0
               ftentox.l   fp0               ; FP0 = D = 10^(k-1)
               fmove.l  fp0,d3
goon                                         
               divs.l   d3,d1                ; Luku / D, jakojnns tippuu
                                             ; automaattisesti
               divsl.l  #10,d2:d1            ; Jako 10:ll viel kerran;
                                             ; jakojnns menee D2:een, miss
                                             ; haluttu digit nyt on.
               add.b    #'0',d2              ; Listn nollan ASCII-koodi
                                             ; saatuun digittiin
               move.b   d2,(a2)+             ; ja talletetaan saatu ASCII-arvo
               dbf      d7,dloop


               move.b   #10,(a2)             ; Rivinvaihto
               bra.s    printthenumber

justzero       move.b   #'0',(a2)+
               move.b   #10,(a2)

printthenumber lea      Number,a0
               bsr      Print                ; Print the number...

;------------------------------------------------------------------------------
; Clean up
;------------------------------------------------------------------------------

CleanUp
               move.l   Dosbase,d0
               beq.s    Pois
               move.l   d0,a1
               LibCall  Exec,CloseLibrary

Pois           movem.l  (sp)+,d2-d7/a2-a6
               clr.l    d0
               rts

;------------------------------------------------------------------------------
; A0:ssa tekstin alkuosoite
;------------------------------------------------------------------------------
Print          move.l   a0,d2
etsi_0         tst.b    (a0)+
               bne.s    etsi_0
               subq.l   #1,a0
               sub.l    d2,a0
               move.l   a0,d3
               move.l   outfile,d1
               LibCall  Dos,Write
               rts

;------------------------------------------------------------------------------
; Constants
;------------------------------------------------------------------------------
dosname        dc.b     "dos.library",0
               even

;-------------------------------------------------------------------------------
; Variables
;-------------------------------------------------------------------------------
   section  Muuttujat,DATA

Dosbase        dc.l     0
outfile        dc.l     0
Number         dc.b     0,0,0,0,0,0,0,0,0,0,0,0

               end
